<template>
  <div class="auth-container">
    <v-card>
      <v-card-title>Entrez votre nouveau mot de passe</v-card-title>
      <v-card-text>
        <v-text-field
          :rules="[rules.required, rules.min]"
          label="Mot de passe"
          v-model="formData.password"
          type="password"
        />
        <v-text-field
          :rules="[rules.required, rules.min, rules.passwordMatch]"
          label="Confirmation du mot de passe"
          v-model="formData.confirmPassword"
          type="password"
        />
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" :ripple="false" text @click="confirmForm()">
          <v-icon>mdi-email</v-icon>Envoyer
        </v-btn>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import UserService from "../../services/userService";
import methods from "../../utils/methods";

@Component
export default class ResetPassword extends Vue {
  private formData = {
    password: "",
    confirmPassword: ""
  };
  private errorMessage = "";

  private rules = {
    required: value => !!value || "Obligatoire.",
    min: v => v.length >= 5 || "Minimum 5 lettres",
    passwordMatch: () => this.formData.password === this.formData.confirmPassword || "Les mots de passe ne correspondent pas."
  };
  private _userService: UserService = null;

  mounted(){
    // Pas de token valide => Redirection
    if(methods.isNullOrEmpty(this.jwt))
      this.$router.push({name: 'home'})
    this._userService = new UserService();
  }
  get jwt(): string | string[] {
    return this.$route.query.jwt;
  }
  private get rulesAreOk(): boolean{
    return this.rules.passwordMatch() !== "Les mots de passe ne correspondent pas." &&
      this.rules.min(this.formData.password) !== "Minimum 5 lettres" &&
      this.rules.required(this.formData.password) !== "Obligatoire."
  }
  private confirmForm(){
    if(this.rulesAreOk){
      this._userService.resetPassword(this.jwt, this.formData.password)
      .then(data => {
        if (data.status === 204)
          (this as any).$noty.success("Votre mot de passe a bien été réinitialisé.").on('afterClose', () => this.$router.push({name: "login"}))
        else
          (this as any).$noty.warning("Une erreur technique survenue, veuillez recommencer.")
        })
      .catch(() => (this as any).$noty.warning("L'opération a échoué"))
    }
  }
}
</script>